import * as webpack from 'webpack';
import * as merge from 'webpack-merge';
import common from './webpack.common';
import * as HtmlWebPackPlugin from "html-webpack-plugin";

const config: webpack.Configuration = merge(
    common,
    {
        mode: "development",
        entry: "./src/ViewSrc/index.ts",
        output: { pathinfo: false },
        devtool: "eval-source-map",
        devServer: {
            contentBase: "./dist/",
            port: 7776,
            hot: true,
        },
        plugins: [
            new webpack.NamedModulesPlugin(),//Hot
            new webpack.HotModuleReplacementPlugin(),//Hot
            new HtmlWebPackPlugin({
                title: "webCAD",
                // template: './src/index.html'
            }),
        ]
    }
);

export default config;
